import { world, system } from "@minecraft/server"

console.warn = () => { };

world.afterEvents.entityDie.subscribe((event) => {
    if (event.damageSource.damagingEntity?.typeId == "minecraft:player") {
        if (event.deadEntity.hasTag("undeadTag")) {
            event.deadEntity.runCommand("/structure load nightmare_fuel ~~~")
        }
    }
});

world.afterEvents.entityHurt.subscribe((event) => {
    if (event.damageSource?.damagingProjectile?.typeId == "bey:poison_arrow") {
        event.hurtEntity.runCommand("/effect @s fatal_poison 2 2")
    }
});

world.afterEvents.entityHurt.subscribe((event) => {
    if (event.damageSource?.damagingProjectile?.typeId == "bey:freeze_arrow") {
        event.hurtEntity.runCommand("/effect @s slowness 3 2")
    }
});

world.afterEvents.entityHurt.subscribe((event) => {
    if (event.damageSource?.damagingProjectile?.typeId == "bey:flame_arrow") {
        event.hurtEntity.runCommand("/fill ~ ~-2 ~ ~ ~1 ~ fire replace air")
    }
});

system.afterEvents.scriptEventReceive.subscribe(({ id, sourceEntity: player }) => {

    if (!player || id !== 'bey:dasher2') return;

    const playerView = player.getViewDirection();
    player.applyKnockback(playerView.x, playerView.z, 7, 0)
    player.runCommand("/scoreboard players add @s dasherCooldown 1")
    player.runCommand("/playsound mob.shulker.shoot @s ~~~")

});

system.afterEvents.scriptEventReceive.subscribe(({ id, sourceEntity: player }) => {

    if (!player || id !== 'bey:dasher') return;

    const playerView = player.getViewDirection();
    player.applyKnockback(playerView.x, playerView.z, 5, 0)
    player.runCommand("/scoreboard players add @s dasherCooldown 1")
    player.runCommand("/playsound mob.shulker.shoot @s ~~~")

});

system.afterEvents.scriptEventReceive.subscribe(({ id, sourceEntity: player }) => {

    if (!player || id !== 'beyond:knockback') return;

    const entities = player.dimension.getEntities({ location: player.location, maxDistance: 6 });

    for (const entity of entities) {
        if (entity.id === player.id) continue;
        const { x, z } = Vector.subtract(entity.location, player.location);
        entity?.applyKnockback(x, z, 3, 0.4);
    }
});

export class Vector {
    static multiply(vectorA, value) {
        return {
            x: vectorA.x * (typeof value === 'number' ? value : value.x),
            y: vectorA.y * (typeof value === 'number' ? value : value.y),
            z: vectorA.z * (typeof value === 'number' ? value : value.z)
        };
    }
    static add(vectorA, vectorB) {
        return {
            x: vectorA.x + (vectorB.x ?? 0),
            y: vectorA.y + (vectorB.y ?? 0),
            z: vectorA.z + (vectorB.z ?? 0)
        };
    }
    static subtract(vectorA, vectorB) {
        return {
            x: vectorA.x - (vectorB.x ?? 0),
            y: vectorA.y - (vectorB.y ?? 0),
            z: vectorA.z - (vectorB.z ?? 0)
        };
    }
    static distance(vectorA, vectorB) {
        return Math.sqrt(Math.pow(vectorA.x - vectorB.x, 2)
            + Math.pow(vectorA.y - vectorB.y, 2)
            + Math.pow(vectorA.z - vectorB.z, 2));
    }
}